



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Reading or Writing to Another Processes Memory in C# z</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Reading or Writing to Another Processes Memory in C# z</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 02:58:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>http://www.jarloo.com/reading-and-writing-to-memory/</p>
<p>Declarations</p>
<div>
<pre class="prettyprint linenums">[Flags]<br />
public enum ProcessAccessFlags : uint<br />
{<br />
    All = 0x001F0FFF,<br />
    Terminate = 0x00000001,<br />
    CreateThread = 0x00000002,<br />
    VMOperation = 0x00000008,<br />
    VMRead = 0x00000010,<br />
    VMWrite = 0x00000020,<br />
    DupHandle = 0x00000040,<br />
    SetInformation = 0x00000200,<br />
    QueryInformation = 0x00000400,<br />
    Synchronize = 0x00100000<br />
}

[DllImport("kernel32.dll")]<br />
private static extern IntPtr OpenProcess(ProcessAccessFlags dwDesiredAccess, [MarshalAs(UnmanagedType.Bool)] bool bInheritHandle, int dwProcessId);

[DllImport("kernel32.dll", SetLastError = true)]<br />
private static extern bool WriteProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress, byte[] lpBuffer, uint nSize, out int lpNumberOfBytesWritten);

[DllImport("kernel32.dll", SetLastError = true)]<br />
static extern bool ReadProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress, [Out] byte[] lpBuffer, int dwSize, out int lpNumberOfBytesRead);

[DllImport("kernel32.dll")]<br />
public static extern Int32 CloseHandle(IntPtr hProcess);</pre>
</div>
<p>Reading from another processes Memory</p>
<div>
<pre class="prettyprint linenums">public static byte[] ReadMemory(Process process, int address, int numOfBytes, out int bytesRead)<br />
{<br />
    IntPtr hProc = OpenProcess(ProcessAccessFlags.All, false, process.Id);

    byte[] buffer = new byte[numOfBytes];

    ReadProcessMemory(hProc, new IntPtr(address), buffer, numOfBytes, out bytesRead);<br />
    return buffer;<br />
}</pre>
</div>
<p>Here is an example of a call to this function:</p>
<div>
<pre class="prettyprint linenums">Process process = Process.GetProcessesByName("My Apps Name").FirstOrDefault();<br />
int address = 0x02ED2910;

int bytesRead;<br />
byte[] value = ReadMemory(process, address, , out bytesRead);</pre>
</div>
<p>Writing to another processes memory</p>
<div>
<pre class="prettyprint linenums">public static bool WriteMemory(Process process, int address, long value, out int bytesWritten)<br />
{<br />
    IntPtr hProc = OpenProcess(ProcessAccessFlags.All, false, process.Id);

    byte[] val = BitConverter.GetBytes(value);

    bool worked = WriteProcessMemory(hProc, new IntPtr(address), val, (UInt32) val.LongLength, out bytesWritten);

    CloseHandle(hProc);

    return worked;<br />
}</pre>
</div>
<p>Here is an example of a call to this function:</p>
<div>
<div><code>Process process = Process.GetProcessesByName(</code><code>"My Apps Name"</code><code>).FirstOrDefault();&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code></div>
<div><code>int</code> <code>address = 0x02ED2910;</code></div>
<div>&nbsp;</div>
<div><code>int</code> <code>bytesWritten;</code></div>
<div><code>bool</code> <code>worked = WriteMemory(process, address, value, </code><code>out</code> <code>bytesWritten);</code></div>
<div>&nbsp;</div>
<div>Readprocessmemory用法</div>
<div>
<p>函数功能：该函数从指定的进程中读入内存信息，被读取的区域必须具有访问权限。</p>
<p>函数原型：BOOL ReadProcessMemory(HANDLE hProcess,LPCVOID lpBaseAddress,LPVOID lpBuffer,DWORD nSize,LPDWORD lpNumberOfBytesRead)；</p>
<p>参数：</p>
<p>hProcess：进程句柄</p>
<p>lpBaseAddress：读出数据的地址</p>
<p>lpBuffer：存放读取数据的地址</p>
<p>nSize：读出的数据大小</p>
<p>lpNumberOfBytesRead：数据的实际大小</p>
<p>C#中使用该函数首先导入命名空间：</p>
<div>
<ol><li>using&nbsp;System.Runtime.InteropServices;</li></ol>
</div>
<p>using System.Runtime.InteropServices;</p>
<p>然后写API引用部分的代码，放入 class 内部</p>
<div>
<ol><li>[DllImport("kernel32.dll&nbsp;")]</li>
<li>static&nbsp;extern&nbsp;bool&nbsp;ReadProcessMemory(int&nbsp;hProcess,&nbsp;int&nbsp;lpBaseAddress,out&nbsp;int&nbsp;lpBuffer,&nbsp;int&nbsp;nSize,&nbsp;out&nbsp;int&nbsp;lpNumberOfBytesRead);</li></ol>
</div>
<p>[DllImport("kernel32.dll ")]<br />
static extern bool ReadProcessMemory(int hProcess, int lpBaseAddress,out int lpBuffer, int nSize, out int lpNumberOfBytesRead);</p>
<p>这个函数有五个参数，第一个参数是 进程句柄，由OpenProcess函数获取；第二个参数是要读出数据的地址，使用CE等辅助工具可取得；第三个参数是用于存放读取数据的地址；第四个参数是 要读出的数据大小；第五个参数是读出数据的实际大小。例如：</p>
<div>
<ol><li>IntPtr&nbsp;hwnd&nbsp;=&nbsp;FindWindow(null,&nbsp;"计算器");</li>
<li>const&nbsp;int&nbsp;PROCESS_ALL_ACCESS&nbsp;=&nbsp;0x1F0FFF;</li>
<li>const&nbsp;int&nbsp;PROCESS_VM_READ&nbsp;=&nbsp;0x0010;</li>
<li>const&nbsp;int&nbsp;PROCESS_VM_WRITE&nbsp;=&nbsp;0x0020;</li>
<li>if&nbsp;(hwnd&nbsp;!=&nbsp;IntPtr.Zero)</li>
<li>{</li>
<li>int&nbsp;calcID;</li>
<li>int&nbsp;calcProcess;</li>
<li>int&nbsp;dataAddress;</li>
<li>int&nbsp;readByte;</li>
<li>GetWindowThreadProcessId(hwnd,&nbsp;out&nbsp;calcID);</li>
<li>calcProcess&nbsp;=&nbsp;OpenProcess(PROCESS_VM_READ&nbsp;|&nbsp;PROCESS_VM_WRITE,&nbsp;false,&nbsp;calcID);</li>
<li>//假设地址0X0047C9D4存在信息</li>
<li>ReadProcessMemory(calcProcess,&nbsp;0X0047C9D4,&nbsp;out&nbsp;dataAddress,&nbsp;4,&nbsp;out&nbsp;readByte);</li>
<li>MessageBox.Show(dataAddress.ToString());</li>
<li>}</li>
<li>else</li>
<li>{</li>
<li>MessageBox.Show("没有找到窗口");</li>
<li>}</li></ol>
</div>
<p>IntPtr hwnd = FindWindow(null, "计算器");<br />
const int PROCESS_ALL_ACCESS = 0x1F0FFF;<br />
const int PROCESS_VM_READ = 0x0010;<br />
const int PROCESS_VM_WRITE = 0x0020;<br />
if (hwnd != IntPtr.Zero)<br />
{<br />
    int calcID;<br />
    int calcProcess;<br />
    int dataAddress;<br />
    int readByte;<br />
    GetWindowThreadProcessId(hwnd, out calcID);<br />
    calcProcess = OpenProcess(PROCESS_VM_READ | PROCESS_VM_WRITE, false, calcID);<br />
    //假设地址0X0047C9D4存在信息<br />
    ReadProcessMemory(calcProcess, 0X0047C9D4, out dataAddress, 4, out readByte);<br />
    MessageBox.Show(dataAddress.ToString());<br />
}<br />
else<br />
{<br />
    MessageBox.Show("没有找到窗口");<br />
}</p>
<p>如果我们读取的一段内存中的数据，我们引入部分可修改成如下：</p>
<div>
<ol><li>//二维数组</li>
<li>[DllImport("kernel32.dll&nbsp;")]</li>
<li>static&nbsp;extern&nbsp;bool&nbsp;ReadProcessMemory(int&nbsp;hProcess,&nbsp;int&nbsp;lpBaseAddress,&nbsp;byte[,]&nbsp;lpBuffer,&nbsp;int&nbsp;nSize,&nbsp;out&nbsp;int&nbsp;lpNumberOfBytesRead);</li>
<li>//一维数组</li>
<li>[DllImport("kernel32.dll&nbsp;")]</li>
<li>static&nbsp;extern&nbsp;bool&nbsp;ReadProcessMemory(int&nbsp;hProcess,&nbsp;int&nbsp;lpBaseAddress,&nbsp;byte[]&nbsp;lpBuffer,&nbsp;int&nbsp;nSize,&nbsp;out&nbsp;int&nbsp;lpNumberOfBytesRead);</li></ol>
</div>
<p>//二维数组<br />
[DllImport("kernel32.dll ")]<br />
static extern bool ReadProcessMemory(int hProcess, int lpBaseAddress, byte[,] lpBuffer, int nSize, out int lpNumberOfBytesRead);<br />
//一维数组<br />
[DllImport("kernel32.dll ")]<br />
static extern bool ReadProcessMemory(int hProcess, int lpBaseAddress, byte[] lpBuffer, int nSize, out int lpNumberOfBytesRead);</p>
<p>由于数组是引用传递，我们不需要写out关键字。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zzke38.html">Web SQL Database实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evnjk9.html">ArcGIS Server注册地理数据库报machine&colon;机器名&lbrack;Oracle&colon;&lpar;null&rpar;&rsqb;错误的修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/4956ggz8.html">Borg Maze&lpar;MST &amp;amp&semi; bfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkzoxq.html">关于Objective-C格式化处理相关规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xjewz8.html">C&plus;&plus; Maps 映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m20njq.html">HMTL笔记&mdash;&mdash;Iframe</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7jvxq.html">CentOS 删除自带的OpenJDK 和 安装SunJDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4om3q.html">2017百度web前端实习生在线笔试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/960j2w49.html">使用MobaXterm远程连接Ubuntu，启动Octave，界面不能正常显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjd0k49.html">salt上编写了备份日志的脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5zj2q.html">C语言  &amp;&num;183&semi;  礼物盒</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl3kvq.html">ThreadPoolExecutor 源码阅读</a>
		</li>
						<li><a href="https://www.batexi.com/a/q251z3wq.html">20180409 Code First</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wmm2zq.html">&lbrack;Writeup&rsqb;奇怪的单点音</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1wr109.html">LibreOJ 6277&period; 数列分块入门 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kdpmxq.html">团队冲刺随笔合集&mdash;Beta阶段</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql171p09.html">Session机制一（基础知识点）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2j3oz8.html">MinGW和MSYS的自动安装 【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql100k19.html">java 23种设计模式，一般情况下，常用的有哪些&quest; 转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmjnlk9.html">NI FPGA板卡程序设计概述</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmkx3k9.html">linux 命令小例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwzj6q.html">cygwin如何断点续传</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2vkoq.html">【转】Cygwin访问Windows驱动器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdrxwl8.html">Eclipse jetty</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd5x3xq.html">李洪强iOS开发之Foundation框架&mdash;结构体</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd130m8.html">【nginx网站性能优化篇&lpar;2&rpar;】反向代理实现Apache与Nginx的动静分离&lpar;LNMPA&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm50xz9.html">eclipse中clean操作中如何将validating除去</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd1lve8.html">查看Linux版本系统信息方法汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vpx638.html">OpenCV在Android平台上的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmkr569.html">svn 版本升级的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
